﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VisualLinq
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        IVisualBucket pipeline;

        public MainWindow()
        {
            InitializeComponent();

// Uncomment these lines to play with multiple "from" clauses
//            VisualSource<int> numbers = new VisualSource<int>(Enumerable.Range(2, 5), canvas, "numbers");
//            Canvas.SetLeft(numbers.Box, Canvas.GetLeft(numbers.Box) + 150);


            VisualSource<string> words = new VisualSource<string>
                (new[] { "the", "quick", "brown", "fox", "jumped", 
                         "over", "the", "lazy", "dog" }, 
                 canvas, "words");

            var query = from word in words
                        where word.Length > 3
                        select new { Word = word, Length = word.Length};

            pipeline = query.End();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            pipeline.Go();
        }
    }
}
